diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/dsdv/model/dsdv-routing-protocol.cc ns-3.34/src/dsdv/model/dsdv-routing-protocol.cc
--- ns-3.33/src/dsdv/model/dsdv-routing-protocol.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/dsdv/model/dsdv-routing-protocol.cc	2021-07-14 10:31:06.000000000 -0700
@@ -241,7 +241,7 @@
 {
   *stream->GetStream () << "Node: " << m_ipv4->GetObject<Node> ()->GetId ()
                         << ", Time: " << Now ().As (unit)
-                        << ", Local time: " << GetObject<Node> ()->GetLocalTime ().As (unit)
+                        << ", Local time: " << m_ipv4->GetObject<Node> ()->GetLocalTime ().As (unit)
                         << ", DSDV Routing table" << std::endl;
 
   m_routingTable.Print (stream, unit);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/dsdv/model/dsdv-rtable.cc ns-3.34/src/dsdv/model/dsdv-rtable.cc
--- ns-3.33/src/dsdv/model/dsdv-rtable.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/dsdv/model/dsdv-rtable.cc	2021-07-14 10:31:06.000000000 -0700
@@ -197,11 +197,29 @@
 void
 RoutingTableEntry::Print (Ptr<OutputStreamWrapper> stream, Time::Unit unit /*= Time::S*/) const
 {
-  *stream->GetStream () << std::setiosflags (std::ios::fixed) << m_ipv4Route->GetDestination () << "\t\t" << m_ipv4Route->GetGateway () << "\t\t"
-                        << m_iface.GetLocal () << "\t\t" << std::setiosflags (std::ios::left)
-                        << std::setw (10) << m_hops << "\t" << std::setw (10) << m_seqNo << "\t"
-                        << std::setprecision (3) << (Simulator::Now () - m_lifeTime).As (unit)
-                        << "\t\t" << m_settlingTime.As (unit) << "\n";
+  std::ostream* os = stream->GetStream ();
+  // Copy the current ostream state
+  std::ios oldState (nullptr);
+  oldState.copyfmt (*os);
+
+  *os << std::resetiosflags (std::ios::adjustfield) << std::setiosflags (std::ios::left);
+
+  std::ostringstream dest, gw, iface, ltime, stime;
+  dest << m_ipv4Route->GetDestination ();
+  gw << m_ipv4Route->GetGateway ();
+  iface << m_iface.GetLocal ();
+  ltime << std::setprecision (3) << (Simulator::Now () - m_lifeTime).As (unit);
+  stime << m_settlingTime.As (unit);
+
+  *os << std::setw (16) << dest.str ();
+  *os << std::setw (16) << gw.str ();
+  *os << std::setw (16) << iface.str ();
+  *os << std::setw (16) << m_hops;
+  *os << std::setw (16) << m_seqNo;
+  *os << std::setw(16) << ltime.str ();
+  *os << stime.str () << std::endl;
+  // Restore the previous ostream state
+  (*os).copyfmt (oldState);
 }
 
 void
@@ -251,13 +269,29 @@
 void
 RoutingTable::Print (Ptr<OutputStreamWrapper> stream, Time::Unit unit /*= Time::S*/) const
 {
-  *stream->GetStream () << "\nDSDV Routing table\n" << "Destination\t\tGateway\t\tInterface\t\tHopCount\t\tSeqNum\t\tLifeTime\t\tSettlingTime\n";
+  std::ostream* os = stream->GetStream ();
+  // Copy the current ostream state
+  std::ios oldState (nullptr);
+  oldState.copyfmt (*os);
+
+  *os << std::resetiosflags (std::ios::adjustfield) << std::setiosflags (std::ios::left);
+
+  *os << "\nDSDV Routing table\n";
+  *os << std::setw (16) << "Destination";
+  *os << std::setw (16) << "Gateway";
+  *os << std::setw (16) << "Interface";
+  *os << std::setw (16) << "HopCount";
+  *os << std::setw (16) << "SeqNum";
+  *os << std::setw (16) << "LifeTime";
+  *os << "SettlingTime" << std::endl;
   for (std::map<Ipv4Address, RoutingTableEntry>::const_iterator i = m_ipv4AddressEntry.begin (); i
        != m_ipv4AddressEntry.end (); ++i)
     {
       i->second.Print (stream, unit);
     }
-  *stream->GetStream () << "\n";
+  *os << std::endl;
+  // Restore the previous ostream state
+  (*os).copyfmt (oldState);
 }
 
 bool
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/dsr/bindings/callbacks_list.py ns-3.34/src/dsr/bindings/callbacks_list.py
--- ns-3.33/src/dsr/bindings/callbacks_list.py	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/dsr/bindings/callbacks_list.py	2021-07-14 10:31:06.000000000 -0700
@@ -11,6 +11,11 @@
     ['void', 'const ns3::Ipv4Header &', 'ns3::Ptr<const ns3::Packet>', 'unsigned int', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Ptr<const ns3::Packet>', 'ns3::Ptr<ns3::Ipv4>', 'unsigned int', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'const ns3::Ipv4Header &', 'ns3::Ptr<const ns3::Packet>', 'ns3::Ipv4L3Protocol::DropReason', 'ns3::Ptr<ns3::Ipv4>', 'unsigned int', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['unsigned short', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['unsigned long', 'unsigned short', 'unsigned short', 'unsigned char', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['unsigned long', 'const ns3::WifiTxVector &', 'unsigned short', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['unsigned long', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['bool', 'unsigned short', 'unsigned char', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Mac48Address', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Ptr<const ns3::Packet>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Ptr<const ns3::ArpCache>', 'ns3::Ipv4Address', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/dsr/helper/dsr-helper.h ns-3.34/src/dsr/helper/dsr-helper.h
--- ns-3.33/src/dsr/helper/dsr-helper.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/dsr/helper/dsr-helper.h	2021-07-14 10:31:06.000000000 -0700
@@ -61,8 +61,9 @@
   /**
    * \brief Construct an DsrHelper from another previously initialized instance
    * (Copy Constructor).
+   * \param o object to copy from
    */
-  DsrHelper (const DsrHelper &);
+  DsrHelper (const DsrHelper &o);
   /**
    * \returns pointer to clone of this DsrHelper
    *
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/dsr/helper/dsr-main-helper.h ns-3.34/src/dsr/helper/dsr-main-helper.h
--- ns-3.33/src/dsr/helper/dsr-main-helper.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/dsr/helper/dsr-main-helper.h	2021-07-14 10:31:06.000000000 -0700
@@ -57,8 +57,9 @@
   /**
    * \brief Construct an DsrMainHelper from another previously initialized instance
    * (Copy Constructor).
+   * \param o object to copy from
    */
-  DsrMainHelper (const DsrMainHelper &);
+  DsrMainHelper (const DsrMainHelper &o);
   /**
    * Install routing to the nodes
    * \param dsrHelper The DSR helper class
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/dsr/model/dsr-fs-header.h ns-3.34/src/dsr/model/dsr-fs-header.h
--- ns-3.33/src/dsr/model/dsr-fs-header.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/dsr/model/dsr-fs-header.h	2021-07-14 10:31:06.000000000 -0700
@@ -150,7 +150,6 @@
   /**
    * \brief Print some information about the packet.
    * \param os output stream
-   * \return info about this packet
    */
   virtual void Print (std::ostream &os) const;
   /**
@@ -299,7 +298,6 @@
   /**
    * \brief Print some information about the packet.
    * \param os output stream
-   * \return info about this packet
    */
   virtual void Print (std::ostream &os) const;
   /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/dsr/model/dsr-option-header.h ns-3.34/src/dsr/model/dsr-option-header.h
--- ns-3.33/src/dsr/model/dsr-option-header.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/dsr/model/dsr-option-header.h	2021-07-14 10:31:06.000000000 -0700
@@ -100,7 +100,6 @@
   /**
    * \brief Print some information about the packet.
    * \param os output stream
-   * \return info about this packet
    */
   virtual void Print (std::ostream &os) const;
   /**
@@ -171,7 +170,6 @@
   /**
    * \brief Print some information about the packet.
    * \param os output stream
-   * \return info about this packet
    */
   virtual void Print (std::ostream &os) const;
   /**
@@ -221,7 +219,6 @@
   /**
    * \brief Print some information about the packet.
    * \param os output stream
-   * \return info about this packet
    */
   virtual void Print (std::ostream &os) const;
   /**
@@ -350,7 +347,6 @@
   /**
    * \brief Print some information about the packet.
    * \param os output stream
-   * \return info about this packet
    */
   virtual void Print (std::ostream &os) const;
   /**
@@ -502,7 +498,6 @@
   /**
    * \brief Print some information about the packet.
    * \param os output stream
-   * \return info about this packet
    */
   virtual void Print (std::ostream &os) const;
   /**
@@ -643,7 +638,6 @@
   /**
    * \brief Print some information about the packet.
    * \param os output stream
-   * \return info about this packet
    */
   virtual void Print (std::ostream &os) const;
   /**
@@ -795,7 +789,6 @@
   /**
    * \brief Print some information about the packet.
    * \param os output stream
-   * \return info about this packet
    */
   virtual void Print (std::ostream &os) const;
   /**
@@ -951,7 +944,6 @@
   /**
    * \brief Print some information about the packet.
    * \param os output stream
-   * \return info about this packet
    */
   virtual void Print (std::ostream &os) const;
   /**
@@ -1098,7 +1090,6 @@
   /**
    * \brief Print some information about the packet.
    * \param os output stream
-   * \return info about this packet
    */
   virtual void Print (std::ostream &os) const;
   /**
@@ -1197,7 +1188,6 @@
   /**
    * \brief Print some information about the packet.
    * \param os output stream
-   * \return info about this packet
    */
   virtual void Print (std::ostream &os) const;
   /**
@@ -1304,7 +1294,6 @@
   /**
    * \brief Print some information about the packet.
    * \param os output stream
-   * \return info about this packet
    */
   virtual void Print (std::ostream &os) const;
   /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/dsr/model/dsr-options.h ns-3.34/src/dsr/model/dsr-options.h
--- ns-3.33/src/dsr/model/dsr-options.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/dsr/model/dsr-options.h	2021-07-14 10:31:06.000000000 -0700
@@ -183,8 +183,7 @@
   /**
    * \brief Remove the duplicates from the route
    *
-   * \param vec List of IPv4 addresses to be clean
-   * \return the route after route shorten
+   * \param [in,out] vec List of IPv4 addresses to clean
    */
   void RemoveDuplicates (std::vector<Ipv4Address>& vec);
   /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/dsr/model/dsr-rcache.h ns-3.34/src/dsr/model/dsr-rcache.h
--- ns-3.33/src/dsr/model/dsr-rcache.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/dsr/model/dsr-rcache.h	2021-07-14 10:31:06.000000000 -0700
@@ -706,28 +706,36 @@
   }
   /**
    * \brief Add ARP cache to be used to allow layer 2 notifications processing
+   * \param a ARP cache
    */
-  void AddArpCache (Ptr<ArpCache>);
+  void AddArpCache (Ptr<ArpCache> a);
   /**
    * \brief Don't use the provided ARP cache any more (interface is down)
+   * \param a ARP cache
    */
   void DelArpCache (Ptr<ArpCache>);
   /**
    * \brief Get callback to ProcessTxError, this callback is trying to use the wifi mac tx error header to notify a link layer drop event, however,
    * it is not fully supported yet
+   * \return The callback to ProcessTxError
    */
   Callback<void, WifiMacHeader const &> GetTxErrorCallback () const
   {
     return m_txErrorCallback;
   }
 
-  /// Handle link failure callback
-  /// \param cb the callback to be set
+  /**
+   * Handle link failure callback
+   * \param cb the callback to be set
+   */
   void SetCallback (Callback<void, Ipv4Address, uint8_t > cb)
   {
     m_handleLinkFailure = cb;
   }
-  /// Handle link failure callback
+  /**
+   * Handle link failure callback
+   * \return The callback to LinkFailure
+   */
   Callback<void, Ipv4Address, uint8_t > GetCallback () const
   {
     return m_handleLinkFailure;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/dsr/model/dsr-routing.h ns-3.34/src/dsr/model/dsr-routing.h
--- ns-3.33/src/dsr/model/dsr-routing.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/dsr/model/dsr-routing.h	2021-07-14 10:31:06.000000000 -0700
@@ -153,86 +153,150 @@
     */
   Ptr<dsr::DsrPassiveBuffer> GetPassiveBuffer () const;
 
-  /// functions used to direct to route cache
-  //\{
+  /**
+   * \brief Checks if the link is cached in the route cache
+   * See also DsrRouteCache::IsLinkCache
+   *
+   * \return true if the link is cached
+   */
   bool IsLinkCache ();
+
+  /**
+   * \brief Extends the lifetime of a route cache entry.
+   * See also DsrRouteCache::UseExtends
+   *
+   * \param rt the route to extend
+   */
   void UseExtends (DsrRouteCacheEntry::IP_VECTOR rt);
+
+  /**
+   * \brief Lookup route cache entry with destination address dst
+   * See also DsrRouteCache::LookupRoute
+   *
+   * \param id destination address
+   * \param rt entry with destination address id, if exists
+   * \return true on success
+   */
   bool LookupRoute (Ipv4Address id, DsrRouteCacheEntry & rt);
+
+  /**
+   * \brief dd route link to cache
+   * See also DsrRouteCache::AddRoute_Link
+   *
+   * \param nodelist vector of nodes
+   * \param source ip address of node to add
+   * \return true if the link is cached
+   */
   bool AddRoute_Link (DsrRouteCacheEntry::IP_VECTOR nodelist, Ipv4Address source);
+
+  /**
+   * \brief Add route cache entry if it doesn't yet exist in route cache
+   * See also DsrRouteCache::AddRoute
+   *
+   * \param rt route cache entry
+   * \return true on success
+   */
   bool AddRoute (DsrRouteCacheEntry & rt);
+
+  /**
+   * \brief Delete all the routes which includes the link from next hop address that has just been notified
+   * as unreachable.
+   * See also DsrRouteCache::DeleteAllRoutesIncludeLink
+   *
+   * \param errorSrc The error source address
+   * \param unreachNode The unreachable node
+   * \param node This node's ip address
+   */
   void DeleteAllRoutesIncludeLink (Ipv4Address errorSrc, Ipv4Address unreachNode, Ipv4Address node);
+
+  /**
+   * \brief Update route cache entry if it has been recently used and successfully delivered the data packet.
+   * See also DsrRouteCache::UpdateRouteEntry
+   *
+   * \param dst destination address of the route
+   * \return true in success
+   */
   bool UpdateRouteEntry (Ipv4Address dst);
+
+  /**
+   * Find the source request entry in the route request queue, return false if not found.
+   * See also DsrRreqTable::FindSourceEntry
+   *
+   * \param src the source address we just received the source request
+   * \param dst the destination address the request is targeted at
+   * \param id the identification number for this request
+   * \return true if found, false otherwise
+   */
   bool FindSourceEntry (Ipv4Address src, Ipv4Address dst, uint16_t id);
-  //\}
 
   /**
-    * \brief Get the netdevice from the context.
-    * \param context context
-    * \return the netdevice we are looking for
-    */
+   * \brief Get the netdevice from the context.
+   * \param context context
+   * \return the netdevice we are looking for
+   */
   Ptr<NetDevice> GetNetDeviceFromContext (std::string context);
   /**
-    * \brief Get the elements from the tracing context.
-    * \param context context
-    * \return the elements we are looking for
-    */
+   * \brief Get the elements from the tracing context.
+   * \param context context
+   * \return the elements we are looking for
+   */
   std::vector<std::string> GetElementsFromContext (std::string context);
   /**
-    * \brief Get the node id from ip address.
-    * \param address IPv4 address
-    * \return the node id
-    */
+   * \brief Get the node id from ip address.
+   * \param address IPv4 address
+   * \return the node id
+   */
   uint16_t GetIDfromIP (Ipv4Address address);
   /**
-    * \brief Get the ip address from id.
-    * \param id unique ID
-    * \return the ip address for the id
-    */
+   * \brief Get the ip address from id.
+   * \param id unique ID
+   * \return the ip address for the id
+   */
   Ipv4Address GetIPfromID (uint16_t id);
   /**
-    * \brief Get the Ip address from mac address.
-    * \param address Mac48Address
-    * \return the ip address
-    */
+   * \brief Get the Ip address from mac address.
+   * \param address Mac48Address
+   * \return the ip address
+   */
   Ipv4Address GetIPfromMAC (Mac48Address address);
   /**
-    * \brief Get the node with give ip address.
-    * \param ipv4Address IPv4 address
-    * \return the node associated with the ip address
-    */
+   * \brief Get the node with give ip address.
+   * \param ipv4Address IPv4 address
+   * \return the node associated with the ip address
+   */
   Ptr<Node> GetNodeWithAddress (Ipv4Address ipv4Address);
   /**
-    * \brief Print the route vector.
-    * \param vec the vector to print.
-    */
+   * \brief Print the route vector.
+   * \param vec the vector to print.
+   */
   void PrintVector (std::vector<Ipv4Address>& vec);
   /**
-    * \brief Get the next hop of the route.
-    * \param ipv4Address
-    * \param vec Route
-    * \return the next hop address of the route
-    */
+   * \brief Get the next hop of the route.
+   * \param ipv4Address
+   * \param vec Route
+   * \return the next hop address of the route
+   */
   Ipv4Address SearchNextHop (Ipv4Address ipv4Address, std::vector<Ipv4Address>& vec);
   /**
-    * \brief Get the dsr protocol number.
-    * \return protocol number
-    */
+   * \brief Get the dsr protocol number.
+   * \return protocol number
+   */
   int GetProtocolNumber (void) const;
   /**
-    * \brief The send buffer timer expire.
-    */
+   * \brief The send buffer timer expire.
+   */
   void SendBuffTimerExpire ();
   /**
-    * \brief Check the send buffer of packets with route when send buffer timer expire.
-    */
+   * \brief Check the send buffer of packets with route when send buffer timer expire.
+   */
   void CheckSendBuffer ();
   /**
-    * \brief When route vector corrupted, originate a new packet, normally not happening.
-    * \param packet to route
-    * \param source address
-    * \param destination address
-    * \param protocol number
-    */
+   * \brief When route vector corrupted, originate a new packet, normally not happening.
+   * \param packet to route
+   * \param source address
+   * \param destination address
+   * \param protocol number
+   */
   void PacketNewRoute (Ptr<Packet> packet,
                        Ipv4Address source,
                        Ipv4Address destination,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/energy/bindings/modulegen__gcc_ILP32.py ns-3.34/src/energy/bindings/modulegen__gcc_ILP32.py
--- ns-3.33/src/energy/bindings/modulegen__gcc_ILP32.py	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/energy/bindings/modulegen__gcc_ILP32.py	2021-07-14 10:31:06.000000000 -0700
@@ -86,12 +86,16 @@
     module.add_class('Ipv4Address', import_from_module='ns.network')
     ## ipv4-address.h (module 'network'): ns3::Ipv4Address [class]
     root_module['ns3::Ipv4Address'].implicitly_converts_to(root_module['ns3::Address'])
+    ## ipv4-address.h (module 'network'): ns3::Ipv4AddressHash [class]
+    module.add_class('Ipv4AddressHash', import_from_module='ns.network')
     ## ipv4-address.h (module 'network'): ns3::Ipv4Mask [class]
     module.add_class('Ipv4Mask', import_from_module='ns.network')
     ## ipv6-address.h (module 'network'): ns3::Ipv6Address [class]
     module.add_class('Ipv6Address', import_from_module='ns.network')
     ## ipv6-address.h (module 'network'): ns3::Ipv6Address [class]
     root_module['ns3::Ipv6Address'].implicitly_converts_to(root_module['ns3::Address'])
+    ## ipv6-address.h (module 'network'): ns3::Ipv6AddressHash [class]
+    module.add_class('Ipv6AddressHash', import_from_module='ns.network')
     ## ipv6-address.h (module 'network'): ns3::Ipv6Prefix [class]
     module.add_class('Ipv6Prefix', import_from_module='ns.network')
     ## li-ion-energy-source-helper.h (module 'energy'): ns3::LiIonEnergySourceHelper [class]
@@ -542,8 +546,10 @@
     register_Ns3EventId_methods(root_module, root_module['ns3::EventId'])
     register_Ns3Hasher_methods(root_module, root_module['ns3::Hasher'])
     register_Ns3Ipv4Address_methods(root_module, root_module['ns3::Ipv4Address'])
+    register_Ns3Ipv4AddressHash_methods(root_module, root_module['ns3::Ipv4AddressHash'])
     register_Ns3Ipv4Mask_methods(root_module, root_module['ns3::Ipv4Mask'])
     register_Ns3Ipv6Address_methods(root_module, root_module['ns3::Ipv6Address'])
+    register_Ns3Ipv6AddressHash_methods(root_module, root_module['ns3::Ipv6AddressHash'])
     register_Ns3Ipv6Prefix_methods(root_module, root_module['ns3::Ipv6Prefix'])
     register_Ns3LiIonEnergySourceHelper_methods(root_module, root_module['ns3::LiIonEnergySourceHelper'])
     register_Ns3LogComponent_methods(root_module, root_module['ns3::LogComponent'])
@@ -1612,6 +1618,18 @@
                    [param('char const *', 'address')])
     return
 
+def register_Ns3Ipv4AddressHash_methods(root_module, cls):
+    ## ipv4-address.h (module 'network'): ns3::Ipv4AddressHash::Ipv4AddressHash() [constructor]
+    cls.add_constructor([])
+    ## ipv4-address.h (module 'network'): ns3::Ipv4AddressHash::Ipv4AddressHash(ns3::Ipv4AddressHash const & arg0) [constructor]
+    cls.add_constructor([param('ns3::Ipv4AddressHash const &', 'arg0')])
+    ## ipv4-address.h (module 'network'): size_t ns3::Ipv4AddressHash::operator()(ns3::Ipv4Address const & x) const [member operator]
+    cls.add_method('operator()', 
+                   'size_t', 
+                   [param('ns3::Ipv4Address const &', 'x')], 
+                   custom_name='__call__', is_const=True)
+    return
+
 def register_Ns3Ipv4Mask_methods(root_module, cls):
     cls.add_output_stream_operator()
     cls.add_binary_comparison_operator('==')
@@ -1825,6 +1843,11 @@
                    'ns3::Ipv6Address', 
                    [param('ns3::Address', 'addr'), param('ns3::Ipv6Address', 'prefix')], 
                    is_static=True)
+    ## ipv6-address.h (module 'network'): static ns3::Ipv6Address ns3::Ipv6Address::MakeAutoconfiguredAddress(ns3::Address addr, ns3::Ipv6Prefix prefix) [member function]
+    cls.add_method('MakeAutoconfiguredAddress', 
+                   'ns3::Ipv6Address', 
+                   [param('ns3::Address', 'addr'), param('ns3::Ipv6Prefix', 'prefix')], 
+                   is_static=True)
     ## ipv6-address.h (module 'network'): static ns3::Ipv6Address ns3::Ipv6Address::MakeAutoconfiguredAddress(ns3::Mac16Address addr, ns3::Ipv6Address prefix) [member function]
     cls.add_method('MakeAutoconfiguredAddress', 
                    'ns3::Ipv6Address', 
@@ -1900,6 +1923,18 @@
                    [param('uint8_t *', 'address')])
     return
 
+def register_Ns3Ipv6AddressHash_methods(root_module, cls):
+    ## ipv6-address.h (module 'network'): ns3::Ipv6AddressHash::Ipv6AddressHash() [constructor]
+    cls.add_constructor([])
+    ## ipv6-address.h (module 'network'): ns3::Ipv6AddressHash::Ipv6AddressHash(ns3::Ipv6AddressHash const & arg0) [constructor]
+    cls.add_constructor([param('ns3::Ipv6AddressHash const &', 'arg0')])
+    ## ipv6-address.h (module 'network'): size_t ns3::Ipv6AddressHash::operator()(ns3::Ipv6Address const & x) const [member operator]
+    cls.add_method('operator()', 
+                   'size_t', 
+                   [param('ns3::Ipv6Address const &', 'x')], 
+                   custom_name='__call__', is_const=True)
+    return
+
 def register_Ns3Ipv6Prefix_methods(root_module, cls):
     cls.add_output_stream_operator()
     cls.add_binary_comparison_operator('==')
@@ -1920,6 +1955,11 @@
     cls.add_constructor([param('ns3::Ipv6Prefix const &', 'prefix')])
     ## ipv6-address.h (module 'network'): ns3::Ipv6Prefix::Ipv6Prefix(ns3::Ipv6Prefix const * prefix) [constructor]
     cls.add_constructor([param('ns3::Ipv6Prefix const *', 'prefix')])
+    ## ipv6-address.h (module 'network'): ns3::Ipv6Address ns3::Ipv6Prefix::ConvertToIpv6Address() const [member function]
+    cls.add_method('ConvertToIpv6Address', 
+                   'ns3::Ipv6Address', 
+                   [], 
+                   is_const=True)
     ## ipv6-address.h (module 'network'): void ns3::Ipv6Prefix::GetBytes(uint8_t * buf) const [member function]
     cls.add_method('GetBytes', 
                    'void', 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/energy/bindings/modulegen__gcc_LP64.py ns-3.34/src/energy/bindings/modulegen__gcc_LP64.py
--- ns-3.33/src/energy/bindings/modulegen__gcc_LP64.py	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/energy/bindings/modulegen__gcc_LP64.py	2021-07-14 10:31:06.000000000 -0700
@@ -86,12 +86,16 @@
     module.add_class('Ipv4Address', import_from_module='ns.network')
     ## ipv4-address.h (module 'network'): ns3::Ipv4Address [class]
     root_module['ns3::Ipv4Address'].implicitly_converts_to(root_module['ns3::Address'])
+    ## ipv4-address.h (module 'network'): ns3::Ipv4AddressHash [class]
+    module.add_class('Ipv4AddressHash', import_from_module='ns.network')
     ## ipv4-address.h (module 'network'): ns3::Ipv4Mask [class]
     module.add_class('Ipv4Mask', import_from_module='ns.network')
     ## ipv6-address.h (module 'network'): ns3::Ipv6Address [class]
     module.add_class('Ipv6Address', import_from_module='ns.network')
     ## ipv6-address.h (module 'network'): ns3::Ipv6Address [class]
     root_module['ns3::Ipv6Address'].implicitly_converts_to(root_module['ns3::Address'])
+    ## ipv6-address.h (module 'network'): ns3::Ipv6AddressHash [class]
+    module.add_class('Ipv6AddressHash', import_from_module='ns.network')
     ## ipv6-address.h (module 'network'): ns3::Ipv6Prefix [class]
     module.add_class('Ipv6Prefix', import_from_module='ns.network')
     ## li-ion-energy-source-helper.h (module 'energy'): ns3::LiIonEnergySourceHelper [class]
@@ -542,8 +546,10 @@
     register_Ns3EventId_methods(root_module, root_module['ns3::EventId'])
     register_Ns3Hasher_methods(root_module, root_module['ns3::Hasher'])
     register_Ns3Ipv4Address_methods(root_module, root_module['ns3::Ipv4Address'])
+    register_Ns3Ipv4AddressHash_methods(root_module, root_module['ns3::Ipv4AddressHash'])
     register_Ns3Ipv4Mask_methods(root_module, root_module['ns3::Ipv4Mask'])
     register_Ns3Ipv6Address_methods(root_module, root_module['ns3::Ipv6Address'])
+    register_Ns3Ipv6AddressHash_methods(root_module, root_module['ns3::Ipv6AddressHash'])
     register_Ns3Ipv6Prefix_methods(root_module, root_module['ns3::Ipv6Prefix'])
     register_Ns3LiIonEnergySourceHelper_methods(root_module, root_module['ns3::LiIonEnergySourceHelper'])
     register_Ns3LogComponent_methods(root_module, root_module['ns3::LogComponent'])
@@ -1612,6 +1618,18 @@
                    [param('char const *', 'address')])
     return
 
+def register_Ns3Ipv4AddressHash_methods(root_module, cls):
+    ## ipv4-address.h (module 'network'): ns3::Ipv4AddressHash::Ipv4AddressHash() [constructor]
+    cls.add_constructor([])
+    ## ipv4-address.h (module 'network'): ns3::Ipv4AddressHash::Ipv4AddressHash(ns3::Ipv4AddressHash const & arg0) [constructor]
+    cls.add_constructor([param('ns3::Ipv4AddressHash const &', 'arg0')])
+    ## ipv4-address.h (module 'network'): size_t ns3::Ipv4AddressHash::operator()(ns3::Ipv4Address const & x) const [member operator]
+    cls.add_method('operator()', 
+                   'size_t', 
+                   [param('ns3::Ipv4Address const &', 'x')], 
+                   custom_name='__call__', is_const=True)
+    return
+
 def register_Ns3Ipv4Mask_methods(root_module, cls):
     cls.add_output_stream_operator()
     cls.add_binary_comparison_operator('==')
@@ -1825,6 +1843,11 @@
                    'ns3::Ipv6Address', 
                    [param('ns3::Address', 'addr'), param('ns3::Ipv6Address', 'prefix')], 
                    is_static=True)
+    ## ipv6-address.h (module 'network'): static ns3::Ipv6Address ns3::Ipv6Address::MakeAutoconfiguredAddress(ns3::Address addr, ns3::Ipv6Prefix prefix) [member function]
+    cls.add_method('MakeAutoconfiguredAddress', 
+                   'ns3::Ipv6Address', 
+                   [param('ns3::Address', 'addr'), param('ns3::Ipv6Prefix', 'prefix')], 
+                   is_static=True)
     ## ipv6-address.h (module 'network'): static ns3::Ipv6Address ns3::Ipv6Address::MakeAutoconfiguredAddress(ns3::Mac16Address addr, ns3::Ipv6Address prefix) [member function]
     cls.add_method('MakeAutoconfiguredAddress', 
                    'ns3::Ipv6Address', 
@@ -1900,6 +1923,18 @@
                    [param('uint8_t *', 'address')])
     return
 
+def register_Ns3Ipv6AddressHash_methods(root_module, cls):
+    ## ipv6-address.h (module 'network'): ns3::Ipv6AddressHash::Ipv6AddressHash() [constructor]
+    cls.add_constructor([])
+    ## ipv6-address.h (module 'network'): ns3::Ipv6AddressHash::Ipv6AddressHash(ns3::Ipv6AddressHash const & arg0) [constructor]
+    cls.add_constructor([param('ns3::Ipv6AddressHash const &', 'arg0')])
+    ## ipv6-address.h (module 'network'): size_t ns3::Ipv6AddressHash::operator()(ns3::Ipv6Address const & x) const [member operator]
+    cls.add_method('operator()', 
+                   'size_t', 
+                   [param('ns3::Ipv6Address const &', 'x')], 
+                   custom_name='__call__', is_const=True)
+    return
+
 def register_Ns3Ipv6Prefix_methods(root_module, cls):
     cls.add_output_stream_operator()
     cls.add_binary_comparison_operator('==')
@@ -1920,6 +1955,11 @@
     cls.add_constructor([param('ns3::Ipv6Prefix const &', 'prefix')])
     ## ipv6-address.h (module 'network'): ns3::Ipv6Prefix::Ipv6Prefix(ns3::Ipv6Prefix const * prefix) [constructor]
     cls.add_constructor([param('ns3::Ipv6Prefix const *', 'prefix')])
+    ## ipv6-address.h (module 'network'): ns3::Ipv6Address ns3::Ipv6Prefix::ConvertToIpv6Address() const [member function]
+    cls.add_method('ConvertToIpv6Address', 
+                   'ns3::Ipv6Address', 
+                   [], 
+                   is_const=True)
     ## ipv6-address.h (module 'network'): void ns3::Ipv6Prefix::GetBytes(uint8_t * buf) const [member function]
     cls.add_method('GetBytes', 
                    'void', 
